<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2019
 *
 * Generated from /home/jon/local/agbud8/htdocs/web/sites/all/civicrm/extensions/org.agbu.annualgrantbudgets/xml/schema/CRM/AnnualGrantBudgets/GrantBudget.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:36ad4daebed0e606747c4c8c53269a42)
 */

/**
 * Database access object for the GrantBudget entity.
 */
class CRM_AnnualGrantBudgets_DAO_GrantBudget extends CRM_Core_DAO {

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  public static $_tableName = 'civicrm_grant_budget';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  public static $_log = TRUE;

  /**
   * Unique GrantBudget ID
   *
   * @var int
   */
  public $id;

  /**
   * FK to Financial Type
   *
   * @var int
   */
  public $financial_type_id;

  /**
   * Fiscal year
   *
   * @var int
   */
  public $fiscal_year;

  /**
   * Grant Annual Budget
   *
   * @var float
   */
  public $budget;

  /**
   * Note
   *
   * @var string
   */
  public $note;

  /**
   * Is this budget item locked for non-administrators?
   *
   * @var bool
   */
  public $is_reserved;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civicrm_grant_budget';
    parent::__construct();
  }

  /**
   * Returns foreign keys and entity references.
   *
   * @return array
   *   [CRM_Core_Reference_Interface]
   */
  public static function getReferenceColumns() {
    if (!isset(Civi::$statics[__CLASS__]['links'])) {
      Civi::$statics[__CLASS__]['links'] = static::createReferenceColumns(__CLASS__);
      Civi::$statics[__CLASS__]['links'][] = new CRM_Core_Reference_Basic(self::getTableName(), 'financial_type_id', 'civicrm_financial_type', 'id');
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'links_callback', Civi::$statics[__CLASS__]['links']);
    }
    return Civi::$statics[__CLASS__]['links'];
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'description' => CRM_AnnualGrantBudgets_ExtensionUtil::ts('Unique GrantBudget ID'),
          'required' => TRUE,
          'where' => 'civicrm_grant_budget.id',
          'table_name' => 'civicrm_grant_budget',
          'entity' => 'GrantBudget',
          'bao' => 'CRM_AnnualGrantBudgets_DAO_GrantBudget',
          'localizable' => 1,
        ],
        'financial_type_id' => [
          'name' => 'financial_type_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => CRM_AnnualGrantBudgets_ExtensionUtil::ts('Financial Type Id'),
          'description' => CRM_AnnualGrantBudgets_ExtensionUtil::ts('FK to Financial Type'),
          'required' => TRUE,
          'import' => TRUE,
          'where' => 'civicrm_grant_budget.financial_type_id',
          'export' => FALSE,
          'table_name' => 'civicrm_grant_budget',
          'entity' => 'GrantBudget',
          'bao' => 'CRM_AnnualGrantBudgets_DAO_GrantBudget',
          'localizable' => 1,
          'html' => [
            'type' => 'Select',
          ],
          'pseudoconstant' => [
            'table' => 'civicrm_financial_type',
            'keyColumn' => 'id',
            'labelColumn' => 'name',
          ],
        ],
        'fiscal_year' => [
          'name' => 'fiscal_year',
          'type' => CRM_Utils_Type::T_INT,
          'title' => CRM_AnnualGrantBudgets_ExtensionUtil::ts('Fiscal Year'),
          'description' => CRM_AnnualGrantBudgets_ExtensionUtil::ts('Fiscal year'),
          'required' => TRUE,
          'import' => TRUE,
          'where' => 'civicrm_grant_budget.fiscal_year',
          'export' => FALSE,
          'table_name' => 'civicrm_grant_budget',
          'entity' => 'GrantBudget',
          'bao' => 'CRM_AnnualGrantBudgets_DAO_GrantBudget',
          'localizable' => 1,
          'html' => [
            'type' => 'Select',
          ],
          'pseudoconstant' => [
            'callback' => 'CRM_Grant_BAO_GrantBudget::getFiscalyear',
          ],
        ],
        'budget' => [
          'name' => 'budget',
          'type' => CRM_Utils_Type::T_MONEY,
          'title' => CRM_AnnualGrantBudgets_ExtensionUtil::ts('Grant Annual Budget'),
          'description' => CRM_AnnualGrantBudgets_ExtensionUtil::ts('Grant Annual Budget'),
          'required' => TRUE,
          'precision' => [
            20,
            2,
          ],
          'import' => TRUE,
          'where' => 'civicrm_grant_budget.budget',
          'export' => TRUE,
          'default' => '0.00',
          'table_name' => 'civicrm_grant_budget',
          'entity' => 'GrantBudget',
          'bao' => 'CRM_AnnualGrantBudgets_DAO_GrantBudget',
          'localizable' => 1,
          'html' => [
            'type' => 'Text',
          ],
        ],
        'note' => [
          'name' => 'note',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => CRM_AnnualGrantBudgets_ExtensionUtil::ts('Note'),
          'description' => CRM_AnnualGrantBudgets_ExtensionUtil::ts('Note'),
          'required' => FALSE,
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'import' => TRUE,
          'where' => 'civicrm_grant_budget.note',
          'export' => TRUE,
          'table_name' => 'civicrm_grant_budget',
          'entity' => 'GrantBudget',
          'bao' => 'CRM_AnnualGrantBudgets_DAO_GrantBudget',
          'localizable' => 1,
          'html' => [
            'type' => 'Text',
          ],
        ],
        'is_reserved' => [
          'name' => 'is_reserved',
          'type' => CRM_Utils_Type::T_BOOLEAN,
          'title' => CRM_AnnualGrantBudgets_ExtensionUtil::ts('Is Reserved'),
          'description' => CRM_AnnualGrantBudgets_ExtensionUtil::ts('Is this budget item locked for non-administrators?'),
          'import' => TRUE,
          'where' => 'civicrm_grant_budget.is_reserved',
          'export' => TRUE,
          'default' => '0',
          'table_name' => 'civicrm_grant_budget',
          'entity' => 'GrantBudget',
          'bao' => 'CRM_AnnualGrantBudgets_DAO_GrantBudget',
          'localizable' => 1,
          'html' => [
            'type' => 'CheckBox',
          ],
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Return a mapping from field-name to the corresponding key (as used in fields()).
   *
   * @return array
   *   Array(string $name => string $uniqueName).
   */
  public static function &fieldKeys() {
    if (!isset(Civi::$statics[__CLASS__]['fieldKeys'])) {
      Civi::$statics[__CLASS__]['fieldKeys'] = array_flip(CRM_Utils_Array::collect('name', self::fields()));
    }
    return Civi::$statics[__CLASS__]['fieldKeys'];
  }

  /**
   * Returns the names of this table
   *
   * @return string
   */
  public static function getTableName() {
    return CRM_Core_DAO::getLocaleTableName(self::$_tableName);
  }

  /**
   * Returns if this table needs to be logged
   *
   * @return bool
   */
  public function getLog() {
    return self::$_log;
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, 'grant_budget', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, 'grant_budget', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
